Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Jobs/JobList.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Jobs/JobList.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Jobs/JobList.cs	(revision 4629)
@@ -0,0 +1,41 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Hive;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Clients.Hive.Jobs {
+  [Item("IJob List", "Represents a list of Hive Job Objects.")]
+  [StorableClass]
+  public class JobList : ItemList<IJob> {
+    public JobList() : base() { }
+    public JobList(int capacity) : base(capacity) { }
+    public JobList(IEnumerable<IJob> collection) : base(collection) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      HiveJobList clone = (HiveJobList)base.Clone(cloner);
+      return clone;
+    }
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Jobs/OptimizerJob.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Jobs/OptimizerJob.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Jobs/OptimizerJob.cs	(revision 4629)
@@ -0,0 +1,349 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Hive;
+
+namespace HeuristicLab.Clients.Hive.Jobs {
+  [StorableClass]
+  public class OptimizerJob : IJob {
+    [Storable]
+    protected IOptimizer optimizer;
+    public IOptimizer Optimizer {
+      get { return optimizer; }
+      set {
+        if (value != optimizer) {
+          if (optimizer != null) DeregisterEvents();
+          optimizer = value;
+          if (optimizer != null) RegisterEvents();
+          OnOptimizerChanged();
+        }
+      }
+    }
+
+    [Storable]
+    protected ILog log;
+    public ILog Log {
+      get { return log; }
+    }
+
+    [Storable]
+    protected bool computeInParallel;
+    public bool ComputeInParallel {
+      get { return computeInParallel; }
+      set {
+        if (computeInParallel != value) {
+          computeInParallel = value;
+          OnComputeInParallelChanged();
+        }
+      }
+    }
+
+    [Storable]
+    private int indexInParentOptimizerList = -1;
+    public int IndexInParentOptimizerList {
+      get { return indexInParentOptimizerList; }
+      set { this.indexInParentOptimizerList = value; }
+    }
+
+
+    [Storable]
+    private bool collectChildJobs;
+    public bool CollectChildJobs {
+      get { return collectChildJobs; }
+      set { collectChildJobs = value; }
+    }
+
+    public OptimizerJob() {
+      this.log = new Log();
+    }
+
+    public OptimizerJob(IOptimizer optimizer)
+      : this() {
+      this.Optimizer = optimizer;
+
+      if (optimizer is Optimization.Experiment) {
+        this.ComputeInParallel = true;
+      } else if (optimizer is Optimization.BatchRun) {
+        this.ComputeInParallel = false;
+      } else {
+        this.ComputeInParallel = false;
+      }
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    protected virtual void AfterDeserialization() {
+      RegisterEvents();
+    }
+
+    /// <summary>
+    /// Casts the Optimizer to an Experiment. Returns null if cast was not successfull.
+    /// </summary>
+    public Optimization.Experiment OptimizerAsExperiment {
+      get { return Optimizer as Optimization.Experiment; }
+    }
+
+    /// <summary>
+    /// Casts the Optimizer to an BatchRun. Returns null if cast was not successfull.
+    /// </summary>
+    public Optimization.BatchRun OptimizerAsBatchRun {
+      get { return Optimizer as Optimization.BatchRun; }
+    }
+
+    #region IJob Members
+
+    public virtual ExecutionState ExecutionState {
+      get { return optimizer.ExecutionState; }
+    }
+
+    public TimeSpan ExecutionTime {
+      get { return optimizer.ExecutionTime; }
+    }
+
+    public virtual void Run() {
+      throw new NotSupportedException();
+    }
+
+    public virtual void Prepare() {
+      optimizer.Prepare();
+    }
+
+    public virtual void Start() {
+      if ((optimizer is Optimization.Experiment && OptimizerAsExperiment.Optimizers.Count == 0) || // experiment would not fire OnStopped if it has 0 optimizers
+          (optimizer is Optimization.BatchRun && OptimizerAsBatchRun.Algorithm == null)) { // batchrun would not fire OnStopped if algorithm == null
+        OnJobStopped();
+      } else {
+        optimizer.Start();
+      }
+    }
+
+    public virtual void Stop() {
+      optimizer.Stop();
+    }
+
+    public virtual void Resume(IEnumerable<IJob> childJobs) {
+      OnJobStopped();
+    }
+
+    public event EventHandler JobStopped;
+    protected virtual void OnJobStopped() {
+      EventHandler handler = JobStopped;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler JobFailed;
+    protected virtual void OnJobFailed(EventArgs<Exception> e) {
+      EventHandler handler = JobFailed;
+      if (handler != null) handler(this, e);
+    }
+
+    public event EventHandler<EventArgs<IJob>> NewChildJob;
+    protected virtual void OnNewChildJob(IJob job) {
+      EventHandler<EventArgs<IJob>> handler = NewChildJob;
+      if (handler != null) handler(this, new EventArgs<IJob>(job));
+    }
+
+    public event EventHandler WaitForChildJobs;
+    protected virtual void OnWaitForChildJobs() {
+      EventHandler handler = WaitForChildJobs;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler DeleteChildJobs;
+    protected virtual void OnDeleteChildJobs() {
+      EventHandler handler = DeleteChildJobs;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler ComputeInParallelChanged;
+    protected virtual void OnComputeInParallelChanged() {
+      EventHandler handler = ComputeInParallelChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler OptimizerChanged;
+    protected virtual void OnOptimizerChanged() {
+      EventHandler handler = OptimizerChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    #endregion
+
+    #region Optimizer Events
+    protected virtual void RegisterEvents() {
+      optimizer.Stopped += new EventHandler(optimizer_Stopped);
+      optimizer.ExceptionOccurred += new EventHandler<EventArgs<Exception>>(optimizer_ExceptionOccurred);
+      optimizer.DescriptionChanged += new EventHandler(optimizer_DescriptionChanged);
+      optimizer.ItemImageChanged += new EventHandler(optimizer_ItemImageChanged);
+      optimizer.NameChanged += new EventHandler(optimizer_NameChanged);
+      optimizer.NameChanging += new EventHandler<CancelEventArgs<string>>(optimizer_NameChanging);
+      optimizer.ToStringChanged += new EventHandler(optimizer_ToStringChanged);
+    }
+    protected virtual void DeregisterEvents() {
+      optimizer.Stopped -= new EventHandler(optimizer_Stopped);
+      optimizer.ExceptionOccurred -= new EventHandler<EventArgs<Exception>>(optimizer_ExceptionOccurred);
+      optimizer.DescriptionChanged -= this.DescriptionChanged;
+      optimizer.ItemImageChanged -= this.ItemImageChanged;
+      optimizer.NameChanged -= this.NameChanged;
+      optimizer.NameChanging -= this.NameChanging;
+      optimizer.ToStringChanged -= this.ToStringChanged;
+    }
+
+    void optimizer_ToStringChanged(object sender, EventArgs e) {
+      this.OnToStringChanged();
+    }
+
+    void optimizer_NameChanging(object sender, CancelEventArgs<string> e) {
+      this.OnNameChanging(e.Value, e.Cancel);
+    }
+
+    void optimizer_NameChanged(object sender, EventArgs e) {
+      this.OnNameChanged();
+    }
+
+    void optimizer_ItemImageChanged(object sender, EventArgs e) {
+      this.OnItemImageChanged();
+    }
+
+    void optimizer_DescriptionChanged(object sender, EventArgs e) {
+      this.OnDescriptionChanged();
+    }
+
+    protected virtual void optimizer_ExceptionOccurred(object sender, EventArgs<Exception> e) {
+      OnJobFailed(e);
+    }
+
+    protected virtual void optimizer_Stopped(object sender, EventArgs e) {
+      OnJobStopped();
+    }
+    #endregion
+
+    #region INamedItem Members
+
+    public bool CanChangeDescription {
+      get { return optimizer.CanChangeDescription; }
+    }
+
+    public bool CanChangeName {
+      get { return optimizer.CanChangeName; }
+    }
+
+    public string Description {
+      get { return optimizer.Description; }
+      set { optimizer.Description = value; }
+    }
+
+    public string Name {
+      get { return optimizer.Name; }
+      set { optimizer.Name = value; }
+    }
+    #endregion
+
+    #region Events
+    public event EventHandler DescriptionChanged;
+    protected virtual void OnDescriptionChanged() {
+      var handler = DescriptionChanged;
+      if(handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler ItemImageChanged;
+    protected virtual void OnItemImageChanged() {
+      var handler = ItemImageChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler ToStringChanged;
+    protected virtual void OnToStringChanged() {
+      var handler = ToStringChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler NameChanged;
+    protected virtual void OnNameChanged() {
+      var handler = NameChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler<CancelEventArgs<string>> NameChanging;
+    protected virtual void OnNameChanging(string value, bool cancel) {
+      var handler = NameChanging;
+      if (handler != null) handler(this, new CancelEventArgs<string>(value, cancel));
+    }
+    #endregion
+
+    #region IItem Members
+
+    public string ItemDescription {
+      get { return optimizer.ItemDescription; }
+    }
+
+    public System.Drawing.Image ItemImage {
+      get { return optimizer.ItemImage; }
+    }
+
+    public string ItemName {
+      get { return optimizer.ItemName; }
+    }
+
+    public Version ItemVersion {
+      get { return optimizer.ItemVersion; }
+    }
+
+    #endregion
+
+    #region IDeepCloneable Members
+
+    public IDeepCloneable Clone(Cloner cloner) {
+      OptimizerJob clone = (OptimizerJob)Activator.CreateInstance(this.GetType());
+      cloner.RegisterClonedObject(this, clone);
+      clone.Optimizer = (IOptimizer)cloner.Clone(this.Optimizer);
+      clone.log = (ILog)cloner.Clone(this.Log);
+      clone.ComputeInParallel = this.ComputeInParallel;
+      clone.IndexInParentOptimizerList = this.IndexInParentOptimizerList;
+      clone.CollectChildJobs = this.CollectChildJobs;
+      clone.RegisterEvents();
+      return clone;
+    }
+
+    #endregion
+
+    #region ICloneable Members
+
+    public object Clone() {
+      return Clone(new Cloner());
+    }
+
+    #endregion
+
+    /// <summary>
+    /// Gets the string representation of the current instance in the format: <c>Name: [null|Value]</c>.
+    /// </summary>
+    /// <returns>The current instance as a string.</returns>
+    public override string ToString() {
+      return Name;
+    }
+
+    public virtual bool IsParallelizable {
+      get { return this.Optimizer is Optimization.Experiment || this.Optimizer is BatchRun; }
+    }
+
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/PersistenceUtil.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/PersistenceUtil.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/PersistenceUtil.cs	(revision 4629)
@@ -0,0 +1,25 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.IO;
+using HeuristicLab.Persistence.Default.Xml;
+
+namespace HeuristicLab.Clients.Hive {
+  public static class PersistenceUtil {
+    public static byte[] Serialize(object obj) {
+      MemoryStream memStream = new MemoryStream();
+      XmlGenerator.Serialize(obj, memStream);
+      byte[] jobByteArray = memStream.ToArray();
+      memStream.Dispose();
+      return jobByteArray;
+    }
+
+    public static T Deserialize<T>(byte[] sjob) {
+      MemoryStream memStream = new MemoryStream(sjob);
+      T job = XmlParser.Deserialize<T>(memStream);
+      memStream.Dispose();
+      return job;
+    }
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Progress/IProgress.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Progress/IProgress.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Progress/IProgress.cs	(revision 4629)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive {
+  public interface IProgress {
+    string Status { get; set; }
+    double ProgressValue { get; set; }
+
+    void Finish();
+
+    event EventHandler Finished;
+    event EventHandler StatusChanged;
+    event EventHandler ProgressValueChanged;
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Progress/IProgressReporter.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Progress/IProgressReporter.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Progress/IProgressReporter.cs	(revision 4629)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive {
+  public interface IProgressReporter {
+    IProgress Progress { get; }
+    bool IsProgressing { get; }
+
+    event EventHandler IsProgressingChanged;
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Progress/Progress.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Progress/Progress.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Progress/Progress.cs	(revision 4629)
@@ -0,0 +1,82 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive {
+  public class Progress : IProgress {
+    private string status;
+    public string Status {
+      get {
+        return this.status;
+      }
+      set {
+        if (this.status != value) {
+          this.status = value;
+          OnStatusChanged();
+        }
+      }
+    }
+
+    private double progressValue;
+    public double ProgressValue {
+      get {
+        return this.progressValue;
+      }
+      set {
+        if (this.progressValue != value) {
+          this.progressValue = value;
+          OnProgressChanged();
+        }
+      }
+    }
+
+    public Progress() { }
+
+    public Progress(string status) {
+      this.Status = status;
+    }
+
+    public void Finish() {
+      OnFinished();
+    }
+
+    #region Event Handler
+    public event EventHandler Finished;
+    private void OnFinished() {
+      var handler = Finished;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler StatusChanged;
+    private void OnStatusChanged() {
+      var handler = StatusChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler ProgressValueChanged;
+    private void OnProgressChanged() {
+      var handler = ProgressValueChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    #endregion
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Properties/Settings.settings
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Properties/Settings.settings	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/Properties/Settings.settings	(revision 4629)
@@ -0,0 +1,12 @@
+﻿<?xml version='1.0' encoding='utf-8'?>
+<SettingsFile xmlns="http://schemas.microsoft.com/VisualStudio/2004/01/settings" CurrentProfile="(Default)" GeneratedClassNamespace="HeuristicLab.Clients.Hive" GeneratedClassName="Settings">
+  <Profiles />
+  <Settings>
+    <Setting Name="HiveUsername" Type="System.String" Scope="User">
+      <Value Profile="(Default)" />
+    </Setting>
+    <Setting Name="HivePassword" Type="System.String" Scope="User">
+      <Value Profile="(Default)" />
+    </Setting>
+  </Settings>
+</SettingsFile>
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceClients/GenerateServiceClients.cmd
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceClients/GenerateServiceClients.cmd	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceClients/GenerateServiceClients.cmd	(revision 4629)
@@ -0,0 +1,29 @@
+echo off
+
+echo.
+echo *******************************************************************************************
+echo Generating HiveService client
+echo.
+
+svcutil.exe ^
+  http://localhost:9001/HiveService/mex ^
+  /out:HiveServiceClient ^
+  /namespace:*,HeuristicLab.Clients.Hive ^
+  /targetClientVersion:Version35 ^
+  /enableDataBinding ^
+  /config:..\app.config ^
+  /reference:..\..\..\HeuristicLab.Services.Hive.Common\3.3\bin\debug\HeuristicLab.Services.Hive.Common-3.3.dll
+
+echo.
+echo ---------------------------------------------------------------------------------------
+echo !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
+echo.
+echo Following modifications have to be done manually in generated data contracts:
+echo  * Remove method "protected void RaisePropertyChanged(string propertyName)" in OKBItem
+echo.
+echo !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
+echo ---------------------------------------------------------------------------------------
+echo.
+echo Generation of OKBService client finished.
+echo *******************************************************************************************
+
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceClients/ServiceClientFactory.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceClients/ServiceClientFactory.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceClients/ServiceClientFactory.cs	(revision 4629)
@@ -0,0 +1,190 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.ServiceModel;
+using HeuristicLab.Common;
+using HeuristicLab.Tracing;
+using HeuristicLab.Services.Hive.Common;
+using System.ServiceModel.Description;
+
+namespace HeuristicLab.Clients.Hive {
+  public class ServiceClientFactory<T> {
+    private static object locker = new object();
+
+    private string endpointName;
+
+    private string username;
+    public string Username {
+      get { return username; }
+      set { 
+        if(username != value) {
+          username = value;
+          this.factory = null;
+        }
+      }
+    }
+
+    private string password;
+    public string Password {
+      set {
+        if (password != value) {
+          password = value;
+          this.factory = null;
+        }
+      }
+    }
+
+    private ChannelFactory<T> factory = null;
+    private Disposable<T> disposableService = null;
+    private int requestCount = 0;
+
+    public ServiceClientFactory(string username, string password, string endpointName) {
+      this.username = username;
+      this.password = password;
+      this.endpointName = endpointName;
+    }
+
+    private T CreateFacade(string endpointName) {
+      lock (locker) {
+        try {
+          return CreateChannel(endpointName);
+        }
+        catch (EndpointNotFoundException ex) {
+          OnExceptionOccured(ex);
+        }
+        return default(T);
+      }
+    }
+
+    protected virtual T CreateChannel(string endpointName) {
+      if (factory == null) {
+        factory = new ChannelFactory<T>(endpointName);
+        factory.Credentials.UserName.UserName = username;
+        factory.Credentials.UserName.Password = password;
+        factory.Credentials.ServiceCertificate.Authentication.CertificateValidationMode = System.ServiceModel.Security.X509CertificateValidationMode.None;
+      }
+      
+      return factory.CreateChannel();
+    }
+
+    public Disposable<T> GetService() {
+      lock (locker) {
+        requestCount++;
+        Logger.Debug("Request for ServiceProxy (count: " + requestCount + ")");
+        if (disposableService != null) {
+          if (GetServiceState() == CommunicationState.Faulted) {
+            DisposeService();
+          }
+        }
+        if (disposableService == null) {
+          disposableService = new Disposable<T>(CreateFacade(this.endpointName));
+          RegisterServiceEvents();
+        }        
+        return disposableService;
+      }
+    }
+
+    private void RegisterServiceEvents() {
+      disposableService.OnDisposing += new EventHandler(disposableService_OnDisposing);
+      ((ICommunicationObject)disposableService.Obj).Faulted += new EventHandler(WcfServicePool_Faulted);
+    }
+
+    private void DeregisterServiceEvents() {
+      disposableService.OnDisposing -= new EventHandler(disposableService_OnDisposing);
+      ((ICommunicationObject)disposableService.Obj).Faulted -= new EventHandler(WcfServicePool_Faulted);
+    }
+
+    private CommunicationState GetServiceState() {
+      return ((ICommunicationObject)disposableService.Obj).State;
+    }
+
+    void WcfServicePool_Faulted(object sender, EventArgs e) {
+      OnExceptionOccured(new CommunicationException(e.ToString()));
+    }
+
+    private void disposableService_OnDisposing(object sender, EventArgs e) {
+      DisposeService();
+    }
+
+    public void DisposeService() {
+      lock (locker) {
+        requestCount--;
+        Logger.Debug("Disposing ServiceProxy (count: " + requestCount + ")");
+        if (requestCount == 0) {
+          try {
+            DeregisterServiceEvents();
+            ServiceUtil.DisposeWcfClient((ICommunicationObject)disposableService.Obj);
+          }
+          catch (Exception e) {
+            OnExceptionOccured(e);
+          }
+          finally {
+            disposableService = null;
+          }
+        } else if (requestCount < 0) {
+          throw new ServiceClientFactoryException("requestCount cannot be less than 0.");
+        }
+      }
+    }
+
+    public event EventHandler<EventArgs<Exception>> ExceptionOccured;
+    private void OnExceptionOccured(Exception e) {
+      lock (locker) {
+        var handler = ExceptionOccured;
+        if (handler != null) handler(this, new EventArgs<Exception>(e));
+      }
+    }
+  }
+
+  public static class ServiceUtil {
+    /// <summary>
+    /// This method changes the endpoint-address while preserving the identity-certificate defined in the config file
+    /// </summary>
+    public static void ReplaceEndpointAddress(ServiceEndpoint endpoint, string hostAddress) {
+      EndpointAddressBuilder builder = new EndpointAddressBuilder(endpoint.Address);
+      UriBuilder uriBuilder = new UriBuilder(builder.Uri);
+      uriBuilder.Host = hostAddress;
+      builder.Uri = uriBuilder.Uri;
+      endpoint.Address = builder.ToEndpointAddress();
+    }
+
+    /// <summary>
+    /// Safely disposes a WCF client proxy object
+    /// </summary>
+    /// <param name="obj"></param>
+    public static void DisposeWcfClient(ICommunicationObject obj) {
+      if (obj != null) {
+        if (obj.State != CommunicationState.Faulted &&
+            obj.State != CommunicationState.Closed) {
+          try { obj.Close(); }
+          catch (CommunicationObjectFaultedException) { obj.Abort(); }
+          catch (TimeoutException) { obj.Abort(); }
+          catch (Exception e) {
+            obj.Abort();
+            Logger.Error(e);
+          }
+        } else
+          obj.Abort();
+      }
+    }
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceClients/ServiceClientFactoryException.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceClients/ServiceClientFactoryException.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Clients.Hive/3.3/ServiceClients/ServiceClientFactoryException.cs	(revision 4629)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive {
+  public class ServiceClientFactoryException : Exception {
+    public ServiceClientFactoryException(string message) : base(message) { }
+  }
+}
